dofile("lua/axistobinary.lua")
dofile("lua/povtobinary.lua")

OnBinaryEventOn = {}
OnBinaryEventOff = {}

function TriggerBinaryEventOn(event)
  if OnBinaryEventOnReciever ~= nil then
    OnBinaryEventOnReciever(event)
  elseif OnBinaryEventOn[event] ~= nil then
    OnBinaryEventOn[event]()
  end
end

function TriggerBinaryEventOff(event)
  if OnBinaryEventOffReciever ~= nil then
    OnBinaryEventOffReciever(event)
  elseif OnBinaryEventOff[event] ~= nil then
    OnBinaryEventOff[event]()
  end
end

function KeyPressed(key)
  TriggerBinaryEventOn(key)
end

function KeyReleased(key)
  TriggerBinaryEventOff(key)
end

function MouseButtonPressed(ButtonId,PosAbsX,PosAbsY,PosRelX,PosRelY,PosRollAbs,PosRollRel)
end

function MouseButtonReleased(ButtonId,PosAbsX,PosAbsY,PosRelX,PosRelY,PosRollAbs,PosRollRel)
end

function MouseMoved(PosAbsX,PosAbsY,PosRelX,PosRelY,PosRollAbs,PosRollRel)
end

function ControllerButtonPressed(ControlerId,ButtonId)
  local key = "C"..ControlerId.."B"..ButtonId
  --io.write("Pressed "..key.."\n")
  TriggerBinaryEventOn(key)
end

function ControllerButtonReleased(ControlerId,ButtonId)
  local key = "C"..ControlerId.."B"..ButtonId
  --io.write("Released "..key.."\n")
  TriggerBinaryEventOff(key)
end

InputControler = {}

function ControllerAxisMoved(ControlerId,AxisId,AxisValue)
  local key = "C"..ControlerId.."A"..AxisId
  --io.write("Moved "..key.." Value "..AxisValue.."\n")
  if InputControler[ControlerId] == nil then
    InputControler[ControlerId] = {}
  end
  if InputControler[ControlerId]._Axis == nil then
    InputControler[ControlerId]._Axis = {}
  end
  if InputControler[ControlerId]._Axis[AxisId] == nil then
    InputControler[ControlerId]._Axis[AxisId] = AxisToBinary.Create(10000,key)
  end
  InputControler[ControlerId]._Axis[AxisId](AxisValue)
end

function ControllerPovMoved(ControlerId,PovId,PovDirection)
  --local key = "C"..ControlerId.."P"..PovId.."D"..PovDirection
  --io.write("Pressed "..key.."\n")
  if InputControler[ControlerId] == nil then
    InputControler[ControlerId] = {}
  end
  if InputControler[ControlerId]._Pov == nil then
    InputControler[ControlerId]._Pov = {}
  end
  if InputControler[ControlerId]._Pov[PovId] == nil then
    local key = "C"..ControlerId.."P"..PovId.."D"
    InputControler[ControlerId]._Pov[PovId] = PovToBinary.Create(key)
  end
  InputControler[ControlerId]._Pov[PovId](PovDirection)
end

function ControllerVec3Moved(ControlerId,Vec3Id, ValueX, ValueY, ValueZ)
end
